"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OBDOuterSubscriber_1 = require("../../model/OBDOuterSubscriber");
function supportedPIDs(pid) {
    if (pid === void 0) { pid = '00'; }
    return function (source) {
        return source.lift(new SupportedPIDsOperator(pid));
    };
}
exports.supportedPIDs = supportedPIDs;
var SupportedPIDsOperator = /** @class */ (function () {
    function SupportedPIDsOperator(pid) {
        this.pid = pid;
    }
    SupportedPIDsOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new SupportedPIDsSubscriber(subscriber, this.pid));
    };
    return SupportedPIDsOperator;
}());
var SupportedPIDsSubscriber = /** @class */ (function (_super) {
    __extends(SupportedPIDsSubscriber, _super);
    function SupportedPIDsSubscriber(destination, pid) {
        var _this = _super.call(this, destination) || this;
        _this.pid = pid;
        return _this;
    }
    /**
     * Return the frequency of execution of this command.
     * @return that this command must be executed every pulse.
     */
    SupportedPIDsSubscriber.prototype.pulse = function () {
        return 1;
    };
    /**
     * Return the string representation of the OBD Read command.
     * @returns the string representation of the OBD Read command
     */
    SupportedPIDsSubscriber.prototype.command = function () {
        return "01 " + this.pid + " 1\r";
    };
    /**
     * Return the name of the OBD Field on OBD Data object.
     * @returns the name of the OBD Field on OBD Data object.
     */
    SupportedPIDsSubscriber.prototype.field = function () {
        return "supportedPIDs.segment" + this.pid;
    };
    /**
     * Parse the OBD response.
     * @param bytes the response read from OBD.
     * @returns the parsed response.
     */
    SupportedPIDsSubscriber.prototype.parse = function (bytes) {
        return parseInt(bytes[2], 16) + (parseInt(bytes[3], 16) * 256) + (parseInt(bytes[3], 16) * 65536) + (parseInt(bytes[3], 16) * 16777216);
    };
    return SupportedPIDsSubscriber;
}(OBDOuterSubscriber_1.OBDOuterSubscriber));
//# sourceMappingURL=supportedPIDs.js.map