"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var OuterSubscriber_1 = require("../internal/OuterSubscriber");
var obdReader_1 = require("../operators/obdReader");
var OBD_NO_DATA = 'NO DATA';
var OBD_OUTPUT_DELIMITER = '\r';
var OBDOuterSubscriber = /** @class */ (function (_super) {
    __extends(OBDOuterSubscriber, _super);
    function OBDOuterSubscriber(destination) {
        return _super.call(this, destination) || this;
    }
    /**
     * Send the command to OBD Reader and try to read the response.
     * @param event The OBD reader event loop.
     */
    OBDOuterSubscriber.prototype._next = function (event) {
        var self = this;
        event.connection.send(this.command()).subscribe({
            error: function (error) { return self.destination.error(error); },
            complete: function () { return self.read(event); }
        });
    };
    /**
     * Read one return from OBD, parse and update event.
     * @param event the OBD reader event loop.
     */
    OBDOuterSubscriber.prototype.read = function (event) {
        var _this = this;
        event.connection.onData().pipe(operators_1.mergeMap(function (data) { return rxjs_1.from(data.split(OBD_OUTPUT_DELIMITER)); }), obdReader_1.obdReader(), operators_1.take(1), operators_1.map(function (result) {
            return OBD_NO_DATA !== result[0] ? _this.parse(result) : OBD_NO_DATA;
        })).subscribe(function (value) {
            var segment = _this.field().match(/supportedPIDs\.(segment[0-9A-F][0-9A-F])/);
            if (segment) {
                event.supportedPIDs(segment[1], value);
            }
            else if (OBD_NO_DATA !== value) {
                event.update(_this.field(), value);
            }
            _this.destination.next(event);
        }, function (error) { return _this.destination.error(error); });
    };
    return OBDOuterSubscriber;
}(OuterSubscriber_1.OuterSubscriber));
exports.OBDOuterSubscriber = OBDOuterSubscriber;
//# sourceMappingURL=OBDOuterSubscriber.js.map