"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var OBDOuterSubscriber_1 = require("../model/OBDOuterSubscriber");
var REG_EX_CAN = /09 02014 0: 49 02 01 (([0-9A-F][0-9A-F]\s){1,7})1: (([0-9A-F][0-9A-F]\s){1,7})2: (([0-9A-F][0-9A-F]\s){1,7})>/;
function vehicleIdentifier() {
    return function (source) {
        return source.lift(new VehicleIdentifierOperator());
    };
}
exports.vehicleIdentifier = vehicleIdentifier;
var VehicleIdentifierOperator = /** @class */ (function () {
    function VehicleIdentifierOperator() {
    }
    VehicleIdentifierOperator.prototype.call = function (subscriber, source) {
        return source.subscribe(new VehicleIdentifierSubscriber(subscriber));
    };
    return VehicleIdentifierOperator;
}());
var VehicleIdentifierSubscriber = /** @class */ (function (_super) {
    __extends(VehicleIdentifierSubscriber, _super);
    function VehicleIdentifierSubscriber(destination) {
        return _super.call(this, destination) || this;
    }
    /**
     * Return the frequency of execution of this command.
     * @return that this command must be executed every pulse.
     */
    VehicleIdentifierSubscriber.prototype.pulse = function () {
        return 0;
    };
    /**
     * Return the string representation of the OBD Read command.
     * @returns the string representation of the OBD Read command
     */
    VehicleIdentifierSubscriber.prototype.command = function () {
        return '09 02\r';
    };
    /**
     * Return the name of the OBD Field on OBD Data object.
     * @returns the name of the OBD Field on OBD Data object.
     */
    VehicleIdentifierSubscriber.prototype.field = function () {
        return 'vehicleIdentifier';
    };
    /**
     * Parse the OBD response.
     * @param bytes the response read from OBD.
     * @returns the parsed response.
     */
    VehicleIdentifierSubscriber.prototype.parse = function (bytes) {
        var vin = bytes[0];
        if (vin.match(REG_EX_CAN)) {
            bytes = vin.replace(REG_EX_CAN, '$1$3$5').match(/[0-9A-F]{2}/g);
        }
        else {
            bytes = ['31', '41', '31', '4A', '43', '35', '34', '34', '34', '52', '37', '32', '35', '32', '33', '36', '37'];
        }
        var result = "";
        for (var _i = 0, bytes_1 = bytes; _i < bytes_1.length; _i++) {
            var byte = bytes_1[_i];
            result += String.fromCharCode(parseInt(byte, 16));
        }
        return result.replace(/\0/g, '');
    };
    return VehicleIdentifierSubscriber;
}(OBDOuterSubscriber_1.OBDOuterSubscriber));
//# sourceMappingURL=vehicleIdentifier.js.map